package rocks.zipcode.io.quiz3.arrays;

/**
 * @author leon on 09/12/2018.
 */
public class TicTacToe {
    String[][] board;

    public TicTacToe(String[][] board) {
        this.board = board;
    }

    public String[] getRow(Integer value) {
        String[] retArr = new String[3];
        for (int i = 0; i < 3; i++) {
            retArr[i] = board[value][i];
        }
        return retArr;
    }

    public String[] getColumn(Integer value) {
        String[] retArr = new String[3];
        for (int i = 0; i < 3; i++) {
            retArr[i] = board[i][value];
        }
        return retArr;
    }

    public Boolean isRowHomogenous(Integer rowIndex) {
        String[] rowArr = getRow(rowIndex);
        for (String s: rowArr) {
            if (!s.equals(rowArr[0])){
                return false;
            }
        }
        return true;
    }

    public Boolean isColumnHomogeneous(Integer columnIndex) {
        String[] colArr = getColumn(columnIndex);
        for (String s: colArr) {
            if (!s.equals(colArr[0])){
                return false;
            }
        }
        return true;
    }

    public String getWinner() {
        for (int i = 0; i < 3; i++) {
            if (isRowHomogenous(i) && board[i][0] == "X"){
                return "X";
            }
            else if (isColumnHomogeneous(i) && board[0][i] == "X"){
                return "X";
            }
            else if (board[0][0] == "X" && board[1][1] == "X" && board[2][2] == "X"){
                return "X";
            }
            else if (board[2][0] == "X" && board[1][1] == "X" && board[0][2] == "X"){
                return "X";
            }
        }
        return "O";
    }
}
